console.log("autoSendMessage.js 加载完毕");

// 监听postMessage
window.onload = () => {
  window.addEventListener("message", function (event) {
    if (event.data && event.data.topic) {
      let { topic, params } = event.data;
      // 自动发送消息
      if (topic === "autoContact") {
        sendMessage(params.message);
        return;
      }

      // 自动发送二次建联消息
      if (topic === "autoSendMessageConnectKol") {
        sendMessage(params.message);
        return;
      }
    }
  });
};

function getReact(a, key) {
  k = Object.keys(a).find((i) => i.startsWith(key));
  return a[k];
}

async function sendMessage(text) {
  console.log("自动发送消息", text);
  var a = document.querySelector(".public-DraftEditor-content");
  var es = getReact(a, "__reactProps").children[0].props.editorState;
  var e = getReact(a, "__reactProps").children[0].props.editor;

  var es2 = Draft.EditorState.push(
    es,
    Draft.ContentState.createFromText(text),
    "adjust-depth"
  );
  e.props.onChange(es2);
  // 第一次执行
  await new Promise((resolve) =>
    setTimeout(() => {
      let btn = document.querySelector('[data-e2e="message-send"]');
      getReact(btn, "__reactProps").onClick();
      resolve();
    }, 300)
  );
  // 第二次执行 如果执行了第一次点击事件之后，发送按钮还存在，那么继续执行第二次点击
  await new Promise((resolve) => {
    setTimeout(() => {
      let btn = document.querySelector('[data-e2e="message-send"]');
      if (btn) {
        getReact(btn, "__reactProps").onClick();
      } else {
        clearDraftValue(es, e, text);
      }
      resolve();
    }, 1000);
  });
}

// 清空文本框消息
function clearDraftValue(es, e, text) {
  let draftText = es.getCurrentContent().getPlainText();
  // 清除内容
  if (draftText === text) {
    const emptyContentState = es.getCurrentContent().createEmpty();
    let es2 = Draft.EditorState.push(es, emptyContentState, "remove-range");
    e.props.onChange(es2);
  }
}
