(function () {
  let messageTool = new MessageTool({
    nameSpace: "checkTTLogin",
  });

  // 监听信息
  messageTool.listenChromeMessage((request, sendResponse) => {
    let { topic, params } = request;

    switch (topic) {
      case "isTiktokLogin":
        handleTiktokLogin(params, sendResponse);
        break;
    }
    return true;
  });

  let timer = 0;
  let timerObj = {
    max: 20,
    num: 0,
    time: 1000,
  };

  // 清除定时器
  function clearTimer() {
    if (timer) {
      clearInterval(timer);
      timer = 0;
      timerObj.num = 0;
    }
  }

  // 验证tiktok登录
  function handleTiktokLogin(params, sendResponse) {
    try {
      clearTimer();
      let loginBtn = null;
      let userInfo = null;
      timer = setInterval(() => {
        timerObj.num += 1;
        // 超时验证
        if (timerObj.num >= timerObj.max) {
          clearTimer();
          messageTool.sendChromeResponse(
            {
              topic: "isTiktokLogin",
              params: {
                isLogin: false,
                tiktokId: params.tiktokId,
              },
            },
            sendResponse
          );
          return;
        }
        // 验证是否有用户信息
        userInfo = document.querySelector('[data-e2e="profile-icon"]');
        if (userInfo) {
          clearTimer();
          setTimeout(() => {
            const jsonStr = sessionStorage.getItem("user_session");
            // const uids = localStorage.getItem("HYBRID_SLARDAR_WEBtiktok_pns_web_runtime");
            messageTool.sendChromeResponse(
              {
                topic: "isTiktokLogin",
                params: {
                  jsonStr,
                  isLogin: true,
                  tiktokId: params.tiktokId,
                },
              },
              sendResponse
            );
          }, 10);
          return;
        }
        // 验证是否有登录按钮
        loginBtn = document.querySelector('[data-e2e="top-login-button"]');
        if (loginBtn) {
          clearTimer();
          messageTool.sendChromeResponse(
            {
              topic: "isTiktokLogin",
              params: {
                isLogin: false,
                tiktokId: params.tiktokId,
              },
            },
            sendResponse
          );
          return;
        }
      }, 1 * timerObj.time);
    } catch (err) {}
  }
})();
