(function () {
  let messageTool = new MessageTool({
    nameSpace: "history",
  });

  messageTool.listenPostMessage((data, event) => {
    let { topic, params } = data;

    switch (topic) {
      case "checkInfluenbaseStatus":
        handleCheckInfluenbaseStatus(params, event);
        break;

      default:
        break;
    }
  });

  // 验证插件是否在 验证插件是否登录，插件是否打开以及插件是否在工作流中，
  function handleCheckInfluenbaseStatus(_params, event) {
    messageTool
      .sendChromeMessage({
        topic: "checkInfluenbaseStatus",
        params: {},
      })
      .then(({ topic, params }) => {
        if (topic === "checkInfluenbaseStatus") {
          let { isOpen, isWorkflow, isLogin } = params;
          messageTool.sendPostMessage(
            {
              topic: "checkInfluenbaseStatus",
              params: {
                isOpen,
                isWorkflow,
                isLogin,
              },
            },
            event
          );
        }
      })
      .catch((err) => {
        console.log(err);
        messageTool.sendPostMessage(
          {
            topic: "checkInfluenbaseStatus",
            params: {
              isOpen: false,
              isWorkflow: false,
              isLogin: false,
            },
          },
          event
        );
      });
  }
})();
