(function () {
  let messageTool = new MessageTool({
    nameSpace: "searchKol",
  });

  let timerObj = {
    time: 1000,
    max: 10,
    num: 0,
  };

  let kolDataSet = new Set(); // 存储达人数据

  // 监听chrome 消息
  messageTool.listenChromeMessage((request, sendResponse) => {
    let { topic, params } = request;

    switch (topic) {
      case "getKolData":
        handleGetKolData(params, sendResponse);
        break;
      case "getKolMoreData":
        handleGetKolMoreData(params, sendResponse);
        break;
      case "getKolDetail":
        handleGetKolDetail(params, sendResponse);
        break;
      default:
        break;
    }
  });

  // 搜索达人
  let timer1 = 0;
  function handleGetKolData(params, sendResponse) {
    let { searchKolTabId } = params;

    clearTimer(timer1, () => {
      timer1 = 0;
    });
    let kolDom = null;
    timer1 = setInterval(() => {
      kolDom = document.querySelector('[data-e2e="search_top-item-list"]');

      if (!kolDom) {
        timerObj.num += 1;
        if (timerObj.num >= timerObj.max) {
          clearTimer(timer1, () => {
            timer1 = 0;
          });

          messageTool.sendChromeResponse(
            {
              topic: "getKolData",
              params: {
                kolData: [],
                searchKolTabId,
              },
            },
            sendResponse
          );
        }
      }

      if (kolDom) {
        clearTimer(timer1, () => {
          timer1 = 0;
        });

        let kolDomList = Array.from(kolDom.children);
        let kolData = [];
        kolDomList.forEach((item) => {
          let uniqueId =
            item.querySelector(`[data-e2e="search-card-user-unique-id"]`)
              ?.innerText || "";

          let avatar =
            item.querySelector('[data-e2e="search-card-desc"] img')?.src || "";

          if (!kolDataSet.has(uniqueId)) {
            kolData.push({
              uniqueId,
              avatar,
            });

            // 添加数据
            kolDataSet.add(uniqueId);
          }
        });

        messageTool.sendChromeResponse(
          {
            topic: "getKolData",
            params: {
              kolData,
              searchKolTabId,
            },
          },
          sendResponse
        );
      }
    }, 1 * timerObj.time);
  }

  // 获取更多达人
  let time3 = 0;
  let oldDomLen = 0;
  function handleGetKolMoreData(params, sendResponse) {
    let { searchKolTabId } = params;

    try {
      clearTimer(time3, () => {
        time3 = 0;
      });

      // 1 判断是否已经到底
      // 2 判断是否有更多数据
      // 3 如果没有更多数据
      // 4 限制性触底 延迟三秒获取dom

      let hasDataDom = "";
      let kolDataDom = [];
      let kolData = [];

      // 滚动条置底
      document.scrollingElement.scrollTop = 10000000; // 设置一个很大的值，使滚动条滚动到底部

      // setTimeout(() => {
        time3 = setInterval(() => {
          // 1 判断是否到底
          hasDataDom = document.querySelector(
            ".css-usx5e-DivNoMoreResultsContainer"
          );

          kolDataDom = Array.from(
            document.querySelector('[data-e2e="search_top-item-list"]')
              ?.childNodes
          );

          // 如果没有更多数据
          if (hasDataDom) {
            kolDataDom.forEach((item) => {
              let uniqueId =
                item.querySelector(`[data-e2e="search-card-user-unique-id"]`)
                  ?.innerText || "";

              // 返回数据
              if (!kolDataSet.has(uniqueId)) {
                kolData.push({
                  uniqueId,
                  avatar:
                    item.querySelector('[data-e2e="search-card-desc"] img')
                      ?.src || "",
                });

                kolDataSet.add(uniqueId);
              }
            });

            messageTool.sendChromeResponse(
              {
                topic: "getKolMoreData",
                params: {
                  kolData,
                  isLoadMore: false,
                  searchKolTabId,
                },
              },
              sendResponse
            );

            clearTimer(time3, () => {
              time3 = 0;
            });
            return;
          }

          // 如果有更多数据
         console.log (kolDataDom.length , oldDomLen, '长度')

          if (kolDataDom.length > oldDomLen) {

            oldDomLen = kolDataDom.length;

            console.log (kolDataDom.length , oldDomLen, '长度11')


            kolDataDom.forEach((item) => {
              let uniqueId =
                item.querySelector(`[data-e2e="search-card-user-unique-id"]`)
                  ?.innerText || "";

              // 返回数据
              if (!kolDataSet.has(uniqueId)) {
                kolData.push({
                  uniqueId,
                  avatar:
                    item.querySelector('[data-e2e="search-card-desc"] img')
                      ?.src || "",
                });

                kolDataSet.add(uniqueId);
              }
            });

            messageTool.sendChromeResponse(
              {
                topic: "getKolMoreData",
                params: {
                  kolData,
                  isLoadMore: true,
                  searchKolTabId,
                },
              },
              sendResponse
            );

            clearTimer(time3, () => {
              time3 = 0;
            });

            return;
          }

          // 如果没有获取到更多数据在多等一会儿
          if (kolDataDom.length === oldDomLen) {
            timerObj.num += 1;
            if (timerObj.num >= timerObj.max) {
              messageTool.sendChromeResponse(
                {
                  topic: "getKolMoreData",
                  params: {
                    kolData: [],
                    isLoadMore: false,
                    searchKolTabId,
                  },
                },
                sendResponse
              );
              clearTimer(time3, () => {
                time3 = 0;
              });

              return;
            }
          }
        }, 3 * timerObj.time);
      // }, 1000);
    } catch (err) {
      messageTool.sendChromeResponse(
        {
          topic: "getKolMoreData",
          params: {
            kolData: [],
            status: "error",
            searchKolTabId,
            isLoadMore: false,
          },
        },
        sendResponse
      );

      console.log(err, "获取更多数据报错");
    }
  }

  // 获取达人详情
  let timer2 = 0;
  async function handleGetKolDetail (params, sendResponse) {
    let { uniqueId, tiktokDetailTabId } = params;
    // 延迟六秒获取达人详情
    // 爬取粉丝数 点赞数 messageId uniqueId 头像 nickname covers link description region
    // setTimeout(async () => {
      let nickname =
        document.querySelector('[data-e2e="user-subtitle"]')?.innerText || "";

        const str = document.querySelector('script#__UNIVERSAL_DATA_FOR_REHYDRATION__')?.innerText
        const region = JSON.parse(str)?.__DEFAULT_SCOPE__?.["webapp.user-detail"]?.userInfo?.user?.region ?? '';

      let mssageVal = null;
      let messageId = "";
      try {
        mssageVal =
          document.querySelector('[data-e2e="message-button"]')?.parentNode
            ?.href || "";
        const match = mssageVal.match(/[?&]u=([^&]+)/);
        messageId = match ? match[1] : "";
      } catch (err) {
        console.log(err, "截取messageId 报错");
      }

      // let followerCountShow =
      //   document.querySelector('[data-e2e="followers-count"]')?.innerText || "";

      // let likesShow =
      //   document.querySelector('[data-e2e="likes-count"]')?.innerText || "";

      // let description =
      //   document.querySelector('[data-e2e="user-bio"]')?.innerText || "";

      // let link = document.querySelector(['[data-e2e="user-link"]'])?.href || "";

      let avatar =
        document.querySelector(['[data-e2e="user-avatar"] img'])?.src || "";

      // 暂时保留
      // let region = "";

      // let covers = await getCoverImgs();

      messageTool.sendChromeResponse(
        {
          topic: "getKolDetail",
          params: {
            from: "kolDetail",
            tiktokDetailTabId,
            uniqueId,
            nickname,
            messageId,
            // followerCountShow,
            // likesShow,
            // description,
            // link,
            avatar,
            region,
            covers: [],
          },
        },
        sendResponse
      );
    // }, 6000);

    // 获取带货视频封面
    function getCoverImgs() {
      return new Promise((resolve) => {
        try {
          clearTimer(timer2, () => {
            timer2 = 0;
          });
          timer2 = setInterval(() => {
            // // 如果没有发送图片 或者 请求图片报错
            // console.log(
            //   Boolean(
            //     document.querySelector(".css-1osbocj-DivErrorContainer")
            //   ),
            //   Boolean(document.querySelector(".css-833rgq-DivShareLayoutMain"))
            // );
            // noPicture =
            //   Boolean(
            //     document.querySelector(".css--tipsosbocj-DivErrorContainer")
            //   ) ||
            //   Boolean(document.querySelector(".css-833rgq-DivShareLayoutMain"));

            // if (noPicture) {
            //   console.log(33333);
            //   clearTimer(timer2, () => {
            //     timer2 = 0;
            //   });
            //   resolve([]);
            //   return;
            // }

            pictures = document.querySelectorAll("[data-e2e='user-post-item']");
            if (pictures.length) {
              pictures = Array.from(pictures).slice(0, 5);
              let videoCovers = [];

              pictures.forEach((item) => {
                let src = item.querySelector("img").src;
                let alt = item.querySelector("img").alt;
                let videoUrl = item.querySelector("a").href;
                videoCovers.push({
                  src,
                  alt,
                  videoUrl,
                });
              });

              resolve(videoCovers);
              clearTimer(timer2, () => {
                timer2 = 0;
              });
            } else {
              timerObj.num += 1;
              if (timerObj.max === timerObj.num) {
                resolve([]);
                clearTimer(timer2, () => {
                  timer2 = 0;
                });
              }
            }
          }, 1 * timerObj.time);
        } catch (err) {
          console.log(err);
          resolve([]);
          clearTimer(timer2, () => {
            timer2 = 0;
          });
        }
      });
    }
  }

  // 清除定时器
  function clearTimer(timer, callback) {
    if (timer) {
      clearInterval(timer);
      timer = 0;
    }
    timerObj.num = 0;
    callback && callback();
  }
})();
